class Explosion {
	constructor(game, texture, atlas, x, y, r, vx, vy, vr){
		this.game = game;
		
		// Rendering
		this.layer = "foreground";
		this.texture = texture;
		this.atlas = atlas;
		
		// Scale
		this.scale = 1;
		this.size = this.scale * 32;
		
		// Physics
		this.x = x;
		this.y = y;
		this.r = r;
		this.vx = vx + (Math.random() * 2 - 1) * game.loop.delta * 2;
		this.vy = vy + (Math.random() * 2 - 1) * game.loop.delta * 2;
		this.vr = vr;
		
		// Debris Particle
		this.maxLife = 0.55;
		this.life = this.maxLife;
	}
	
	
	update(delta){
		// Physics
		this.x += this.vx * delta * 60;
		this.y += this.vy * delta * 60;
		this.r += this.vr * delta * 60;
		
		return this.life -= delta;
	}
	
	
	draw(context, textures, atlas){
		var texture = this.texture,
			map = this.atlas[Math.floor((1 - this.life/this.maxLife) * this.atlas.length)];
		
		context.save();
		context.translate(this.x, this.y);
		context.rotate(this.r/180*Math.PI);
		
		context.drawImage(texture, map[0], map[1], map[2], map[3], -this.size/2, -this.size/2, this.size, this.size);

		context.restore();
	
	}
}
